from logging import exception
import os
from csv import DictReader
from collections import OrderedDict
from risefor_lobbying.models import ActionGroup, ActionGroup,Representative,representativeContactPlateform,Tag
from django.core.management.base import BaseCommand
from django.db.models import Value
from django.db.models.functions import Concat
from django.conf import settings
import urllib.request
import re

import risefor_lobbying

class Command(BaseCommand):
    help = 'Imports action groups'

    def import_csv(self, options, file_name):
        targetedRepresentativesFile = './risefor_lobbying/elected-officials/clean-targeted-representatives.csv'
        with open(targetedRepresentativesFile, encoding='utf-8') as targetedRepsFile:
            targetedRepresentatives = DictReader(targetedRepsFile)
            representativeKeys = OrderedDict()
            representativeIndex = 0
            for representative in targetedRepresentatives:
                repName = representative['PRENOM'] + " " + representative['NOM']
                repPostalCodes = representative['ALL POSTAL CODES']
                representativeKeys[representativeIndex] = [repName,repPostalCodes]
                # print("rep keys",representativeKeys[representativeIndex])
                representativeIndex += 1
            # print('targeted reps are',targetedRepresentatives)
            # for e in targetedRepresentatives:
                # print(e)

        with open(file_name, encoding='utf-8') as csvFile:
                csvReader = DictReader(csvFile)
                i = 0
                for row in csvReader:
                    # print(row)
                    action_group = ActionGroup()
                    ################
                        # ALREADY CREATED SEARCH REMOVED
                        # DUE TO DIFFERENT ACTIONS HAVING SAME NAME
                        ### removed for Terre de Luttes, can be compatible for other projects

                    already_created = ActionGroup.objects.filter(name__iexact=row["Projet et lieu"].strip()).exists()
                    if already_created:
                        action_group = ActionGroup.objects.filter(name__iexact=row["Projet et lieu"].strip()).get()
                        # print("already exists",action_group,"update mode")
                        
                    # if not already_created:
                        # print("not created")

                    # print("action group is",action_group)

                    ######
                    # Upload action info
                    # all imports assume fixutres have been used on first deployment
                    ######

                    # global data                    
                    action_group.name = row["Projet et lieu"].strip() #if row["Titre"].strip() != "" else row["Nom complet"] 
                    # print("action : ",action_group.name,)
                    action_group.status = 'active'
                    action_group.objective = "Interpeller les candidats de votre circonscription pour qu’iels se positionnent contre les projets imposés et polluants de votre territoire !"
                    # action_group.objective = "Demandez à votre Candiat.e au législative de prendre position sur " + action_group.name
                    action_group.description = row["Description"]
                    action_group.actioninfolink= row["URL article"]
                    action_group.linkOrganisation = row["URL collectif1"]
                    action_group.organisation = row["Nom du collectif1"]
                    action_group.emailOrganisation = row["mail collectif1"]
                    action_group.linkOrganisation = row["URL collectif1"]
                    # action_group.tags = row['Catégorie']
                    actionCategory = row['Catégorie']

                    #image action based off the category
                    if actionCategory:
                        imagePath = ''
                        if actionCategory == 'Bétonnage':
                            action_group.image = imagePath + 'betonnage.png'
                        elif actionCategory == 'Énergie':
                            action_group.image = imagePath + 'energie.png'
                        elif actionCategory == 'Transports':
                            action_group.image = imagePath + 'transport.png'
                        elif actionCategory == 'Agriculture':
                            action_group.image = imagePath + 'agriculture.png'
                        elif actionCategory == 'Déchets':
                            action_group.image = imagePath + 'decher.png'
                        elif actionCategory == 'Industries':
                            action_group.image = imagePath + 'industriel.png'
                        elif actionCategory == 'Commerce':
                            action_group.image = imagePath + 'transport.png'
                        
                        else:
                            print("image : no category match")

                    # action_group.actiondate= row[""]
                    # action_group.image= row[""]
                    # # location
                    action_group.city = row["Localité"]
                    action_group.postcode = row["Code Postal"]
                    # ISSUE '\xa0\xa0' string in long/lat, unable to remove
                    # workaround -> search for (-)\d+.\d+ pattern
                    long = re.search('(\d+\.\d+|-\d+\.\d+)',row["Longitude"])
                    lat = re.search('(\d+\.\d+|-\d+\.\d+)',row["Latitude"])
                    action_group.lng = long.group() if long != None else None
                    action_group.lat = lat.group() if lat != None else None
                    # currentRepresentative = chosenTargetedOfficial.objects.filter(name__iexact="Candidat.e.s").exists()
                    # print("current rep",currentRepresentative)
                    # action_group.targetedOfficials = row[""]
                    # action_group.contactPlateforms = row[""]
                    

                    ########
                    #EMAIL CONTENT
                    ########

                    ### email info for reps, senators & candidates

                    # action_group.electedofficialEmailSubject = row[""]
                    # action_group.electedofficialEmailText = row[""]
                    # action_group.senatorEmailSubject = row[""]
                    # action_group.senatorEmailText = row[""]
                    # action_group.candidateEmailSubject = row["email - sujet"]
                    # action_group.candidateEmailText = row["email contenu"]
                
                    ### Specific targeted reps

                    #get first letter to see if it's a,e,i,o,u,y
                    #if so, then in email content add a "d'" before the project name
                    #else add "de" 

                    actioNamNoLocality = row["Nom du projet"]
                    actionNameFirstLetter = action_group.name[0].lower()
                    actionNameStopWord = "de "
                    vowels = ['a','e','i','o','u','y']

                    if actionNameFirstLetter in vowels:
                        # print("action starts with vowel",actionNameFirstLetter,action_group.name)
                        actionNameStopWord = "d'"
                    ## title of section
                    action_group.targetedRepresentativesTitle = "Contactez les canditat•e•s"
                    action_group.targetedEmailSubject = row["email - sujet"]
                    action_group.targetedEmailSubject = re.sub('%nom projet%',actioNamNoLocality,action_group.targetedEmailSubject,flags=re.IGNORECASE)
                    #search for text to replace
                    action_group.targetedEmailText = row["email - contenu"]
                    action_group.targetedEmailText = re.sub('%nom du projet%',actionNameStopWord+actioNamNoLocality.lower(),action_group.targetedEmailText,flags=re.IGNORECASE)
                    action_group.targetedEmailText = re.sub('%catégorie%',actionCategory,action_group.targetedEmailText,flags=re.IGNORECASE)
                    action_group.targetedEmailText = re.sub('%nom du collectif%','"'+action_group.organisation+'"',action_group.targetedEmailText,flags=re.IGNORECASE)



                    
                    # action_group.targetedEmailSubject = 
                    # action_group.targetedEmailText
                    
                    # # twitter info
                    # action_group.TweetMain = row[""]
                    # action_group.Tweet2 = row[""]
                    # action_group.Tweet3 = row[""]
                    # action_group.Tweet4 = row[""]
                    # action_group.senatorTweetMain = row[""]
                    # action_group.senatorTweet2 = row[""]
                    # action_group.senatorTweet3 = row[""]
                    # action_group.senatorTweet4 = row[""]
                    # action_group.candidateTweetMain = row[""]
                    # action_group.candidateTweet2 = row[""]
                    # action_group.candidateTweet3 = row[""]
                    # action_group.candidateTweet4 = row[""]
                    # #call info representativeCallObjective
                    # action_group.representativeCallArgumentation = row[""]
                    # action_group.senatorCallObjective = row[""]
                    # action_group.senatorCallArgumentation = row[""]
                    # action_group.candidateCallObjective = row[""]
                    # action_group.candidateCallArgumentation = row[""]

                    action_group.targetedTweetMain = row["Tweet 1"]
                    action_group.targetedTweetMain = re.sub('%nom du projet%',action_group.name,action_group.targetedTweetMain,flags=re.IGNORECASE)
                    
                    action_group.targetedTweet2 = row["Tweet 2"]
                    action_group.targetedTweet2 = re.sub('%Nom du projet%',action_group.name,action_group.targetedTweet2,flags=re.IGNORECASE)

                    try:
                        action_group.targetedTweet3 = row["Tweet 3"]
                        action_group.targetedTweet3 = re.sub('%Nom du projet%',action_group.name,action_group.targetedTweet3,flags=re.IGNORECASE)
                    except KeyError:
                        pass
                    
                    try:
                        action_group.targetedTweet4 = row["Tweet 4"]
                        action_group.targetedTweet4 = re.sub('%Nom du projet%',action_group.name,action_group.targetedTweet4,flags=re.IGNORECASE)
                    except KeyError:
                        pass
                    
                    
                    action_group.save()
                    
                    ###########
                    # UPLOADS THAT NEED A GROUP ID FIRST
                    ###########
                    # Add tags
                    tagModel = Tag()
                    tagCheck = Tag.objects.filter(name__iexact=actionCategory).exists()
                    existingTags = Tag.objects.all()
                    # print("tag check",tagCheck,existingTags)
                    #########
                    # TODO HERE : FIX TAG MATCHING ISSUE
                    if tagCheck is True:
                        action_group.tags.add(Tag.objects.filter(name__iexact=actionCategory)[0])
                    else:
                        tagModel.name = actionCategory
                        tagModel.save()
                        action_group.tags.add(Tag.objects.filter(name__iexact=tagModel.name)[0])
                

                    # Add targeting platforms choices
                    action_group.contactPlateforms.add(representativeContactPlateform.objects.filter(name__icontains='Twitter')[0])
                    action_group.contactPlateforms.add(representativeContactPlateform.objects.filter(name__icontains='Email')[0])
                    # print("chosen platforms",action_group.contactPlateforms)

                    ###########
                    # SEARCH FOR REPRESENTATIVES MATCHING THE POSTAL CODE OF PROJECT
                    ###########
                    actionPostalCode = row['Code Postal'].strip()
                    print("postal code is :",actionPostalCode+".")
                    actionRepresentatives = [] 
                    if actionPostalCode:
                        for index,representativeValues in representativeKeys.items():
                            # print("rep values is ",representativeValues[1])
                            if actionPostalCode in representativeValues[1]:
                                # print("match",representativeValues[0],actionPostalCode)
                                #if there's a match, add the name to list so that we can then search & link
                                actionRepresentatives.append(representativeValues[0])
                        # print("action reps",actionRepresentatives)
                        for localRepresentativeName in actionRepresentatives:
                            representativeModel = Representative()
                            existingRepresentative = Representative.objects.filter(fullname__iexact=localRepresentativeName).exists()
                            if existingRepresentative:
                                action_group.specificTargetedRepresentatives.add(Representative.objects.filter(fullname__iexact=localRepresentativeName)[0])
                            # print('representative match',action_group.name,localRepresentativeName,existingRepresentative)

                    ###########
                    # SAVE NEW CHANGES
                    ###########
                    action_group.save()
                    print("action n°"+str(i)+" - ",action_group.name," imported")
                    i = i + 1        
                    if options['dev'] and i > 5:
                        break

    def add_arguments(self, parser):
        parser.add_argument(
            '--dev',
            action='store_true',
            help='Dummy data for development',
        )

        parser.add_argument(
            '--filename',
            help='Name of file to upload'
        )
    
    def handle(self, *args, **options):
        
        args = options
        print(f"args foo is {args['dev']}, "+args['filename'])
        filename =  args['filename']
        if filename:
            if 'None' in filename:
                raise ValueError("Use the flag --filename to specify the name of the file to upload")
        
        filename = 'data/actions/'+filename+'.csv'
        print("filename",filename)
        rise_for_lobbying_path = os.path.abspath(os.path.dirname(risefor_lobbying.__file__))
        file_name = os.path.join(rise_for_lobbying_path,
                                 #'elected-officials/clean-action_group-db.csv')
                                 filename)
        self.import_csv(options=options, file_name=file_name)
