import os
from csv import DictReader
from risefor_lobbying.models import Representative
from django.core.management.base import BaseCommand

import risefor_lobbying
import unidecode

def cleanAccentuation(text):
    text = unidecode.unidecode(text)
    return text


class Command(BaseCommand):
    help = 'Imports representatives'
    def delete_csv(self, options, file_name):
        print("delete representatives in file",file_name)
        with open(file_name) as csvFile:
            csvReader = DictReader(csvFile)
            deletedCount = 0
            for row in csvReader:
                # print(row)
                fullName = row["PRENOM"] + " "+ row["NOM"]
                # fullName = 'test senateurice'
                already_created = Representative.objects.filter(fullname__iexact=fullName).exists()
                if already_created:
                    print("deleting : ",fullName, deletedCount)
                    Representative.objects.filter(fullname__iexact=fullName).delete()
                    deletedCount += 1
    

    def add_arguments(self, parser):
        parser.add_argument(
            '--dev',
            action='store_true',
            help='Dummy data for development',
        )

        # parser.add_argument(
        #     '--filename',
        #     help='Name of file to upload'
        # )
    
    
        

    def handle(self, *args, **options):
        
        args = options
        print(f"args foo is {args['dev']}, ")
        rise_for_lobbying_path = os.path.abspath(os.path.dirname(risefor_lobbying.__file__))

        file_name = os.path.join(rise_for_lobbying_path,
                    'elected-officials/delete-representatives.csv')
        self.delete_csv(options=options,file_name=file_name)
