from django.core.management.base import BaseCommand
from data_manager.models import Representative
from django.db.models import Value
from django.db.models.functions import Concat
from csv import DictReader
import csv

class Command(BaseCommand):
    help = 'Inserts additionnal information to representatives'

    def import_csv(self, file_name):
        with open(file_name) as csvFile:
            csvReader = DictReader(csvFile)
            representatives = Representative.objects.annotate(search_name=Concat('firstname', Value(' '), 'lastname'))

            for row in csvReader:

                try:
                    representative = representatives.get(search_name__iexact=row['name'])
                
                    representative.permanent_commission = row['permanent_commission']
                    representative.parliamentary_missions = row['parliamentary_missions']
                    representative.additional_functions = row['additional_functions']
                    representative.study_groups = row['study_groups']
                    representative.photo = row['photo']

                    if 'website' in row : 
                        representative.website = row['website']

                    representative.save()

                except Representative.DoesNotExist:
                    print(row['name'] + ' not found in database')

    def handle(self, *args, **options):
        self.import_csv('officials_downsized_database/elected_officials_additional_data.csv')
        #self.import_csv('officials_downsized_database/elected_officials_senators_additional_data.csv')
