import os
from csv import DictReader
from risefor_lobbying.models import Representative,TwitterAccount, Phone, Email,representativeFunction,commissionPermanente,missionParlementaire,groupeEtude,Countrie
from django.core.management.base import BaseCommand
from django.db.models import Value
from django.db.models.functions import Concat
from django.conf import settings
import risefor_lobbying

import re
import uuid
import random



class Command(BaseCommand):
    help = 'Imports representatives'

    def import_csv(self, options, file_name):
        with open(file_name) as csvFile:
            csvReader = DictReader(csvFile)
            i = 0

            # Importing elected from file
            for row in csvReader:
                #already_created = Representative.objects.filter(firstname__iexact=row["PRENOM"],
                                                                #lastname__iexact=row["NOM"]).exists()
                already_created = Representative.objects.filter(fullname__iexact=row["name"]).exists()
                if already_created:
                    print("already exists",row["name"])
                if not already_created:
                    representative = Representative()
                    try:
                        representative.civility = row["civilite"]
                    except KeyError:
                        representative.civility = ''
                        pass
                    #representative.firstname = row["PRENOM"].capitalize()
                    #representative.lastname = row["NOM"].capitalize()
                    representative.fullname  = row["name"]
                    print("importing", i, representative.fullname)
                    #representative.title = row["TITRE"].capitalize()
                    #representative.protocol_role = row["PROTOCOLE ROLE"].capitalize()
                    #representative.protocol_person = row["PROTOCOLE PERSONNE"].capitalize()
                    representative.political_party = row["political_party"]
                    #representative.election_department = row["election_department"]
                    representative.election_region = row["election_region"].capitalize()
                    #representative.phone_organization = row["TEL ORGANISME"]
                    #representative.email_organization = row["EMAIL ORGANISME"]
                    #representative.address1 = row["ADRESSE 1"]
                    #representative.address2 = row["ADRESSE 2"]
                    #representative.postal_code = row["CP"]
                    #representative.city = row["VILLE"].capitalize()
                    #representative.country = row["PAYS"].capitalize()
                    #representative.organization_type = row["TYPE"].capitalize()
                    #representative.organization_subtype = row["SOUS TYPE"].capitalize()
                    representative.commune = row["COMMUNE"]
                    representative.twitter = row["twitter"]
                    #representative.position_campagne = row["Soutien_RIP"].capitalize()
                    
                    try:
                        representative.photo = row["photo"]
                    except KeyError:
                        pass
                     
                    #clean ";" seperator to a line break
                    #if row["website"]
                    #representative.website = row["website"]

                    #new fields
                    #url nos-deputes
                    #functions

                    #representative.circonscription = row["circonscription"]
                    
                    #representative.profession = row["profession"].replace("[","").replace("]","")

                    
                    #representative.facebook = row["facebook"]

                    
                    #####
                    #HANDLE Empty IMAGES
                        #   If sex given, personnalize image
                        #   else add male default
                    #####
                    if representative.photo is '':
                        if representative.civility is not '':
                            if ("Mme" in representative.civility) or ("Mlle" in representative.civility) or ("Ma" in representative.civility):
                                representative.photo = settings.BASE_URL+"/static/img/avatar_f.png"
                            else:
                                representative.photo = settings.BASE_URL+"/static/img/avatar_h.png"
                        else:
                            representative.photo = settings.BASE_URL+"/static/img/avatar_h.png"
                    """
                    if "MME" in row["CIVILITE"]:
                        representative.photo = settings.SITE_URL + "static/img/avatar_f.png"
                    else:
                        representative.photo = settings.SITE_URL + "static/img/avatar_h.png"
                    """

                    #IMPORT REPRESENTATIVE Main commission
                    """
                    if row["permanentCommission"]:
                        commission = commissionPermanente()
                        commissionCheck = commissionPermanente.objects.filter(name__iexact=row["permanentCommission"]).exists()
                        existingCommission = commissionPermanente.objects.all()
                        
                        #print("the commission is" , row["COMMISSION PERMANENTE"] ,"and",exists)
                        if commissionCheck is True:
                            representative.permanentCommission = existingCommission.get(name__iexact=row["permanentCommission"])
                        else:
                            commission.name = row["permanentCommission"]
                            commission.save()
                            representative.permanentCommission = existingCommission.get(name__iexact=commission.name)
                    """
                    #IMPORT REPRESENTATIVE Function
                    if row["function"]:
                        function = representativeFunction()
                        functionCheck = representativeFunction.objects.filter(name__iexact=row["function"]).exists()
                        existingFunction = representativeFunction.objects.all()
                        
                        #print("the function is" , row["COMMISSION PERMANENTE"] ,"and",exists)
                        if functionCheck is True:
                            representative.function = existingFunction.get(name__iexact=row["function"])
                        else:
                            function.name = row["function"]
                            function.save()
                            representative.function = existingFunction.get(name__iexact=function.name)

                    #save Representative
                    representative.save()


                    """
                    #IMPORT REPRESENTATIVE Parlementary missions
                    if row["parliamentaryMissions"]:
                        #get the Parliamentary Mission model
                        ParliamentaryMission = missionParlementaire()
                        #get the values of missions in column
                        thisRepresentativeMissions = row["parliamentaryMissions"].split(";")
                        #get all exiting parliamentaryMissions
                        existingParliamentaryMissions = missionParlementaire.objects.all()

                        #for each new value, check if it exists
                        for thisRepresentativeMission in thisRepresentativeMissions:
                            ######### 
                            # CLEAN NAME && EXTRACT POST IF IT'S THERE
                                #1st, remove post that is between parenthasis (president, vice, etc)
                            thisRepresentativeMission = thisRepresentativeMission.split("(")
                            thisRepresentativeMission = thisRepresentativeMission[0]  

                            ######### 
                            # HANDLE CREATION OF NEW OBJECT 
                            exists = existingParliamentaryMissions.filter(name__iexact=thisRepresentativeMission).exists()
                            
                            #if it doesn't exist, 
                            if exists is False:
                                # create it
                                ParliamentaryMission.name = thisRepresentativeMission
                                ParliamentaryMission.id = uuid.uuid4().int & (1<<45)-1
                                ParliamentaryMission.urlid = '' 
                                ParliamentaryMission.save()
                            
                            #add the mission to the representative's model
                            representative.parliamentaryMissions.add(missionParlementaire.objects.filter(name__iexact=thisRepresentativeMission)[0])


                    #IMPORT REPRESENTATIVE study groups
                    if row["studyGroups"]:
                        #get the Study group model
                        studyGroups = groupeEtude()
                        #get the values of missions in column
                        thisRepresentativeGroups = row["studyGroups"].split(";")
                        #for each new value, check if it exists
                        for thisRepresentativeGroup in thisRepresentativeGroups: 
                            ######### 
                            # CLEAN NAME && EXTRACT POST IF IT'S THERE
                                #1st, remove post that is between parenthasis (president, vice, etc)
                            thisRepresentativeGroup = thisRepresentativeGroup.split("(")
                            thisRepresentativeGroup = thisRepresentativeGroup[0]  

                            #print("groupe étude",thisRepresentativeGroup)
                            #get all exiting studyGroups
                            existingStudyGroups = groupeEtude.objects.all()
                            exists = existingStudyGroups.filter(name__iexact=thisRepresentativeGroup).exists()
                            #if it doesn't exist, 
                            if exists is False:
                                # create it
                                #print("existing",existingStudyGroups.filter(name__iexact=thisRepresentativeGroup))
                                studyGroups.name = thisRepresentativeGroup
                                studyGroups.id = uuid.uuid4().int & (1<<45)-1
                                studyGroups.urlid = ''
                                studyGroups.save()
                            #add the mission to the representative's model
                            representative.studyGroups.add(groupeEtude.objects.filter(name__iexact=thisRepresentativeGroup)[0])
                     
                    """
                    
                    #Import country code
                    if row["country"]:
                        #get the Study group model
                        countries = Countrie()                        
                        countryCheck = Countrie.objects.filter(name__iexact=row["country"]).exists()
                        existingCountry = Countrie.objects.all()
                        
                        if countryCheck is True:
                            representative.representativeCountry = existingCountry.get(name__iexact=row["country"])
                        else:
                            countries.name = row["country"]
                            countries.country = row["country"]
                            countries.save()
                            representative.representativeCountry = existingCountry.get(name__iexact=countries.name)
                        representative.save()


                    #IMPORT CONTANCT INFO
                    
                    #TODO
                        #handle multiple inputs
                    if row["email"]:
                        if ";" in row["email"]:
                            emails = row["email"].split(";")
                            for newEmail in emails:
                                newEmail = newEmail.replace(" ","")
                                newEmail = newEmail.replace("-","")
                                if newEmail:
                                    email = Email()
                                    email.name = newEmail
                                    email.representative = representative
                                    email.save()

                        else:
                            email = Email()
                            email.name = row["email"]
                            email.representative = representative
                            email.save()

                    
                    if row["twitter"]:
                        newTwitter = row["twitter"]
                        newTwitter = newTwitter.replace("[","")
                        newTwitter = newTwitter.replace("]","")
                        newTwitter = newTwitter.replace("'","")
                        if newTwitter:
                            if (";" in newTwitter) or ("," in newTwitter):
                                if ";" in newTwitter:
                                    twitterAccounts = newTwitter.split(";")
                                if "," in newTwitter:
                                    twitterAccounts = newTwitter.split(",")
                                    
                                for newTwitter in twitterAccounts:
                                    newTwitter = newTwitter.replace(" ","")
                                    newTwitter = newTwitter.replace("-","")
                                    if newTwitter:
                                        twitter = TwitterAccount()
                                        twitter.name = newTwitter
                                        twitter.representative = representative
                                        twitter.save()

                            else:
                                twitter = TwitterAccount()
                                twitter.name = newTwitter
                                twitter.representative = representative
                                twitter.save()


                    if row["phone"]:
                        newPhone = row["phone"]
                        newPhone = newPhone.replace("[","")
                        newPhone = newPhone.replace("]","")
                        newPhone = newPhone.replace("'","")
                        if newPhone:
                            if (";" in newPhone) or ("," in newPhone):
                                if ";" in newPhone:
                                    phones = newPhone.split(";")
                                if "," in newPhone:
                                    phones = newPhone.split(",")
                                    
                                for newPhone in phones:
                                    newPhone = newPhone.replace(" ","")
                                    newPhone = newPhone.replace("-","")
                                    if newPhone:
                                        phone = Phone()
                                        phone.name = newPhone
                                        phone.representative = representative
                                        phone.save()

                            else:
                                phone = Phone()
                                phone.name = newPhone
                                phone.representative = representative
                                phone.save()



                    i = i + 1
                    if options['dev'] and i > 10:
                        break

            # Associating assistants with elected
            #TODO
                #handle new format multiple inputs
            for representative in Representative.objects.all():
                if (representative.function == 'Attache parlementaire'):
                    title_array = representative.title.split(' madame ')
                    title_array = title_array[len(title_array) - 1].split(' monsieur ')
                    assistant_name = title_array[len(title_array) - 1]

                    elected_officials = Representative.objects.annotate(
                        search_name=Concat('firstname', Value(' '), 'lastname'))
                    try:
                        elected_official = elected_officials.get(search_name__iexact=assistant_name)
                        elected_official.assistants.add(representative)
                        elected_official.save()
                    except Representative.DoesNotExist:
                        print(assistant_name + ' not found in database')

    def add_arguments(self, parser):
        parser.add_argument(
            '--dev',
            action='store_true',
            help='Dummy data for development',
        )

    def handle(self, *args, **options):
        rise_for_lobbying_path = os.path.abspath(os.path.dirname(risefor_lobbying.__file__))
        file_name = os.path.join(rise_for_lobbying_path,
                                 'elected-officials/clean-candidates.csv')
        self.import_csv(options=options, file_name=file_name)
