import risefor_lobbying
from risefor_lobbying.models import ActionGroup
from server.logging_config import setup_logging
from django.core.management.base import BaseCommand
from datetime import datetime,date,timedelta
from django.utils.translation import ugettext as _

logger = setup_logging('DEBUG')


class Command(BaseCommand):
    help = 'Uploads data to the law_tracker models'
    def add_arguments(self, parser):
        parser.add_argument(
            '--dev',
            action='store_true',
            help='Dummy data for development',
        )
        parser.add_argument("--yes","-y",action="store_true",help="Yes to questions, exept critical")

    def handle(self, *args, **kwargs):
        logger.debug(f"start update {self}")
        actionGroups = ActionGroup.objects.all()
        for instance in actionGroups:
            logger.debug(f"Action model is {instance}")
            display = ''
            if instance.endactiondate:
                logger.debug(f'Start updating action date {instance.endactiondate}')
                # diff = instance.endactiondate - datetime.today().date()
                endDate = instance.endactiondate
                today = datetime.today().date()
                #.strftime('%d-%m-%Y')
                if endDate < today:
                    display = _('Action terminée le ') + endDate.strftime('%d/%m/%Y')
                
                elif endDate == today:
                    display = _('Dernier jour pour agir !')
                    
                elif (endDate - today) <= timedelta(days=7) :
                    diff = endDate - today
                    display = str(diff.days) +" "+ _('jours restant pour agir')
                else:
                    display = _('Agissez avant le ') + endDate.strftime('%d/%m/%Y')
            else:
                display=''
            ActionGroup.objects.filter(pk=instance.pk).update(
                displaydate=display
            )
            logger.success(f'action date for {instance.name} updated as {display}')
