import risefor_lobbying
from risefor_lobbying.models import ActionGroup,actionMapSignUp
from server.logging_config import setup_logging
from django.core.management.base import BaseCommand
from datetime import datetime,date,timedelta
from django.utils.translation import ugettext as _

logger = setup_logging('DEBUG')


class Command(BaseCommand):
    help = 'Uploads data to the law_tracker models'
    def add_arguments(self, parser):
        parser.add_argument(
            '--dev',
            action='store_true',
            help='Dummy data for development',
        )
        parser.add_argument("--yes","-y",action="store_true",help="Yes to questions, exept critical")

    def handle(self, *args, **kwargs):
        allMapActions =  actionMapSignUp.objects.all()
        today = datetime.today().strftime('%Y-%m-%d')
        for action in allMapActions:
            logger.info(f"start update {action.name}")
            eventDate = action.dateDePassage
            if eventDate < date.today():
                action.status = 'passed'
            elif eventDate == date.today():
                action.status = 'today'
            else:
                action.status = 'to-come'
            action.save()
        