#!/bin/bash

# Print current working directory (for debugging purposes)
pwd

# Define paths
BASE_DIR="/Users/senza/Documents/Risefor/law-tracker"
SCRIPT_DIR="$BASE_DIR/law_tracker/management"
SCRIPT_PATH="$SCRIPT_DIR/commands/script-launcher.py"
VENV_PATH="$BASE_DIR/env/"

# Define cron schedule
CRON_SCHEDULE="*/1 * * * *"

# Define command to run the script using the virtual environment
# CRON_COMMAND="$VENV_PATH/bin/python3 $SCRIPT_PATH"
# For testing, you can use a simple echo command
CRON_COMMAND="echo 'Start cron job 3'"

# Full cron job command
CRON_JOB="$CRON_SCHEDULE cd $SCRIPT_DIR && $CRON_COMMAND >> $BASE_DIR/law_tracker/logs/cronjob_update.log 2>&1"

# Check if cron job already exists to avoid duplicates
if crontab -l | grep -F "$CRON_COMMAND" > /dev/null
then
    echo "Cron job already exists."
else
    # Add the cron job to the current user's crontab
    (crontab -l ; echo "$CRON_SCHEDULE cd $SCRIPT_DIR && $CRON_COMMAND >> $BASE_DIR/law_tracker/logs/cronjob_update.log 2>&1") | crontab -
    echo "Cron job added."
fi