# Generated by Django 2.2.16 on 2021-02-04 23:22

from django.db import migrations, models
import django.db.models.deletion
import djangoldp.fields


class Migration(migrations.Migration):

    dependencies = [
        ('risefor_lobbying', '0044_auto_20210126_1700'),
    ]

    operations = [
        migrations.CreateModel(
            name='additionalFunction',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('urlid', djangoldp.fields.LDPUrlField(blank=True, null=True, unique=True)),
                ('is_backlink', models.BooleanField(default=False, help_text='set automatically to indicate the Model is a backlink')),
                ('allow_create_backlink', models.BooleanField(default=True, help_text='set to False to disable backlink creation after Model save')),
                ('name', models.CharField(blank=True, max_length=100, null=True, verbose_name='Nom de la commission')),
            ],
        ),
        migrations.CreateModel(
            name='commissionPermanente',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('urlid', djangoldp.fields.LDPUrlField(blank=True, null=True, unique=True)),
                ('is_backlink', models.BooleanField(default=False, help_text='set automatically to indicate the Model is a backlink')),
                ('allow_create_backlink', models.BooleanField(default=True, help_text='set to False to disable backlink creation after Model save')),
                ('name', models.CharField(blank=True, max_length=100, null=True, verbose_name='Nom de la commission')),
            ],
        ),
        migrations.CreateModel(
            name='commissionPermanenteFunction',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('urlid', djangoldp.fields.LDPUrlField(blank=True, null=True, unique=True)),
                ('is_backlink', models.BooleanField(default=False, help_text='set automatically to indicate the Model is a backlink')),
                ('allow_create_backlink', models.BooleanField(default=True, help_text='set to False to disable backlink creation after Model save')),
                ('name', models.CharField(blank=True, max_length=100, null=True, verbose_name='Nom de la commission')),
            ],
        ),
        migrations.CreateModel(
            name='groupeEtude',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('urlid', djangoldp.fields.LDPUrlField(blank=True, null=True, unique=True)),
                ('is_backlink', models.BooleanField(default=False, help_text='set automatically to indicate the Model is a backlink')),
                ('allow_create_backlink', models.BooleanField(default=True, help_text='set to False to disable backlink creation after Model save')),
                ('name', models.CharField(blank=True, max_length=100, null=True, verbose_name='Nom de la commission')),
            ],
        ),
        migrations.CreateModel(
            name='groupeEtudeFunction',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('urlid', djangoldp.fields.LDPUrlField(blank=True, null=True, unique=True)),
                ('is_backlink', models.BooleanField(default=False, help_text='set automatically to indicate the Model is a backlink')),
                ('allow_create_backlink', models.BooleanField(default=True, help_text='set to False to disable backlink creation after Model save')),
                ('name', models.CharField(blank=True, max_length=100, null=True, verbose_name='Nom de la commission')),
            ],
        ),
        migrations.CreateModel(
            name='missionParlementaire',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('urlid', djangoldp.fields.LDPUrlField(blank=True, null=True, unique=True)),
                ('is_backlink', models.BooleanField(default=False, help_text='set automatically to indicate the Model is a backlink')),
                ('allow_create_backlink', models.BooleanField(default=True, help_text='set to False to disable backlink creation after Model save')),
                ('name', models.CharField(blank=True, max_length=100, null=True, verbose_name='Nom de la commission')),
            ],
        ),
        migrations.CreateModel(
            name='missionParlementaireFunction',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('urlid', djangoldp.fields.LDPUrlField(blank=True, null=True, unique=True)),
                ('is_backlink', models.BooleanField(default=False, help_text='set automatically to indicate the Model is a backlink')),
                ('allow_create_backlink', models.BooleanField(default=True, help_text='set to False to disable backlink creation after Model save')),
                ('name', models.CharField(blank=True, max_length=100, null=True, verbose_name='Nom de la commission')),
            ],
        ),
        migrations.RemoveField(
            model_name='representative',
            name='additional_functions',
        ),
        migrations.RemoveField(
            model_name='representative',
            name='parliamentary_missions',
        ),
        migrations.AlterField(
            model_name='representative',
            name='permanent_commission',
            field=models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, related_name='commissionPermanente', to='risefor_lobbying.commissionPermanente', verbose_name='Commission permanente'),
        ),
        migrations.RemoveField(
            model_name='representative',
            name='study_groups',
        ),
        migrations.AddField(
            model_name='representative',
            name='parliamentary_missionsFunction',
            field=models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, related_name='missionParlementaireFunction', to='risefor_lobbying.missionParlementaireFunction', verbose_name='Fonction missions parlementaires'),
        ),
        migrations.AddField(
            model_name='representative',
            name='permanent_commissionFunction',
            field=models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, related_name='commissionPermanenteFunction', to='risefor_lobbying.missionParlementaireFunction', verbose_name='Fonction commission permanente'),
        ),
        migrations.AddField(
            model_name='representative',
            name='study_groupsFunction',
            field=models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, related_name='groupeEtudeFunction', to='risefor_lobbying.groupeEtudeFunction', verbose_name="Fonction groupe d'étude"),
        ),
        migrations.AddField(
            model_name='representative',
            name='additional_functions',
            field=models.ManyToManyField(blank=True, null=True, related_name='additionalFunction', to='risefor_lobbying.additionalFunction', verbose_name='Fonctions additionnels'),
        ),
        migrations.AddField(
            model_name='representative',
            name='parliamentary_missions',
            field=models.ManyToManyField(blank=True, null=True, related_name='missionParlementaire', to='risefor_lobbying.missionParlementaire', verbose_name='missions parlementaires'),
        ),
        migrations.AddField(
            model_name='representative',
            name='study_groups',
            field=models.ManyToManyField(blank=True, null=True, related_name='study_groups', to='risefor_lobbying.groupeEtude', verbose_name="Groupes d'études"),
        ),
    ]
