# Generated by Django 2.2.16 on 2021-05-20 15:38

from django.db import migrations, models
import django.db.models.deletion
import djangoldp.fields


class Migration(migrations.Migration):

    dependencies = [
        ('risefor_lobbying', '0068_auto_20210511_2204'),
    ]

    operations = [
        migrations.AlterField(
            model_name='email',
            name='representative',
            field=models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, related_name='directEmails', to='risefor_lobbying.Representative', verbose_name="Email de l'élu"),
        ),
        migrations.AlterField(
            model_name='phone',
            name='representative',
            field=models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, related_name='directPhones', to='risefor_lobbying.Representative', verbose_name='Élu'),
        ),
        migrations.CreateModel(
            name='Senator',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('urlid', djangoldp.fields.LDPUrlField(blank=True, null=True, unique=True)),
                ('is_backlink', models.BooleanField(default=False, help_text='set automatically to indicate the Model is a backlink')),
                ('allow_create_backlink', models.BooleanField(default=True, help_text='set to False to disable backlink creation after Model save')),
                ('civility', models.CharField(blank=True, max_length=100, null=True, verbose_name='Civilité')),
                ('firstname', models.CharField(blank=True, max_length=100, null=True, verbose_name='Prénom')),
                ('lastname', models.CharField(blank=True, max_length=100, null=True, verbose_name='Nom')),
                ('fullname', models.CharField(blank=True, max_length=100, null=True, verbose_name='Nom complet')),
                ('title', models.CharField(blank=True, max_length=255, null=True, verbose_name='Titre')),
                ('political_party', models.CharField(blank=True, max_length=100, null=True, verbose_name='Parti politique')),
                ('photo', models.ImageField(upload_to='', verbose_name='Photo')),
                ('slug', models.SlugField(blank=True, null=True, unique=True)),
                ('election_department', models.CharField(blank=True, max_length=100, null=True, verbose_name="Département d'élection")),
                ('election_region', models.CharField(blank=True, max_length=100, null=True, verbose_name="Région d'élection")),
                ('address1', models.CharField(blank=True, max_length=255, null=True, verbose_name='Adresse 1')),
                ('address2', models.CharField(blank=True, max_length=255, null=True, verbose_name='Adresse 2')),
                ('postal_code', models.CharField(blank=True, max_length=255, null=True, verbose_name='Code postal')),
                ('city', models.CharField(blank=True, max_length=150, null=True, verbose_name='Ville')),
                ('commune', models.TextField(blank=True, verbose_name='Commune et Code postal')),
                ('country', models.CharField(blank=True, max_length=150, null=True, verbose_name='Pays')),
                ('website', models.CharField(blank=True, max_length=150, null=True, verbose_name='Site web')),
                ('email_direct', models.EmailField(blank=True, max_length=100, null=True, verbose_name='Email direct')),
                ('email_organization', models.EmailField(blank=True, max_length=100, null=True, verbose_name='Email Organisation')),
                ('twitter', models.URLField(blank=True, max_length=9999999, null=True, verbose_name="Compte twitter de l'élu")),
                ('position_campagne', models.CharField(blank=True, max_length=255, verbose_name="Position de l'élue sur la campange")),
                ('organization_type', models.CharField(blank=True, max_length=150, null=True, verbose_name="Type d'organisation")),
                ('organization_subtype', models.CharField(blank=True, max_length=150, null=True, verbose_name="Sous-type d'organisation")),
                ('protocol_role', models.CharField(blank=True, max_length=100, null=True, verbose_name='Rôle protocolaire')),
                ('protocol_person', models.CharField(blank=True, max_length=100, null=True, verbose_name='Personne protocolaire')),
                ('phone_organization', models.CharField(blank=True, max_length=50, null=True, verbose_name='Tél. organisation')),
                ('circonscription', models.CharField(blank=True, max_length=15, null=True, verbose_name='Circonscription')),
                ('profession', models.CharField(blank=True, max_length=150, null=True, verbose_name='Metier')),
                ('facebook', models.CharField(blank=True, max_length=150, null=True, verbose_name='Facebook')),
                ('additionalFunctions', models.ManyToManyField(blank=True, related_name='senator_additionalFunction', to='risefor_lobbying.additionalFunction', verbose_name='Fonctions additionnels')),
                ('assistants', models.ManyToManyField(blank=True, to='risefor_lobbying.Representative')),
                ('function', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, related_name='senator_representativePosition', to='risefor_lobbying.representativeFunction', verbose_name='Fonction commission permanente')),
                ('parliamentaryMissions', models.ManyToManyField(blank=True, related_name='senator_missionParlementaire', to='risefor_lobbying.missionParlementaire', verbose_name='missions parlementaires')),
                ('parliamentaryMissionsFunction', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, related_name='senator_missionParlementaireFunction', to='risefor_lobbying.parliamentaryPosition', verbose_name='Fonction missions parlementaires')),
                ('permanentCommission', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, related_name='senator_commissionPermanente', to='risefor_lobbying.commissionPermanente', verbose_name='Commission permanente')),
                ('permanentCommissionFunction', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, related_name='senator_commissionPermanenteFunction', to='risefor_lobbying.parliamentaryPosition', verbose_name='Fonction commission permanente')),
                ('studyGroups', models.ManyToManyField(blank=True, related_name='senator_study_groups', to='risefor_lobbying.groupeEtude', verbose_name="Groupes d'études")),
                ('studyGroupsFunction', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, related_name='senator_groupeEtudeFunction', to='risefor_lobbying.parliamentaryPosition', verbose_name="Fonction groupe d'étude")),
            ],
            options={
                'ordering': ['?'],
            },
        ),
        migrations.AddField(
            model_name='email',
            name='senator',
            field=models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, related_name='directEmails', to='risefor_lobbying.Senator', verbose_name="Email de l'élu"),
        ),
        migrations.AddField(
            model_name='phone',
            name='senator',
            field=models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, related_name='directPhones', to='risefor_lobbying.Senator', verbose_name='Élu'),
        ),
    ]
