# Generated by Django 2.2.16 on 2023-11-26 15:06

from django.conf import settings
from django.db import migrations, models
import django.db.models.deletion
import djangoldp.fields


class Migration(migrations.Migration):

    dependencies = [
        migrations.swappable_dependency(settings.AUTH_USER_MODEL),
        ('risefor_lobbying', '0162_financecampaign'),
    ]

    operations = [
        migrations.CreateModel(
            name='ConsultationPublic',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('urlid', djangoldp.fields.LDPUrlField(blank=True, null=True, unique=True)),
                ('is_backlink', models.BooleanField(default=False, help_text='set automatically to indicate the Model is a backlink')),
                ('allow_create_backlink', models.BooleanField(default=True, help_text='set to False to disable backlink creation after Model save')),
                ('created_at', models.DateTimeField(auto_now_add=True)),
                ('name', models.CharField(max_length=255, verbose_name='Nom de la consultation')),
                ('status', models.CharField(choices=[('active', 'Active'), ('pending', 'Pending'), ('inappropriate', 'Inappropriate'), ('finished', 'Finished Action')], default='active', max_length=32, verbose_name='action status')),
                ('instanceName', models.CharField(default='localhost', max_length=255, verbose_name="Nom de l'instance")),
                ('instanceHostName', models.CharField(default='http://localhost:8000', max_length=255, verbose_name="Domaine de l'instance")),
                ('objective', models.TextField(verbose_name='Objectif')),
                ('description', models.TextField(blank=True, null=True, verbose_name='Contexte / Description')),
                ('enddate', models.DateField(blank=True, null=True, verbose_name='Date de fin de la consultation')),
                ('consultationLink', models.URLField(blank=True, max_length=9999999, null=True, verbose_name='Lien vers la consultation')),
                ('image', models.ImageField(blank=True, null=True, upload_to='', verbose_name='Image Tablette et Ordinateur')),
                ('mobileImage', models.ImageField(blank=True, null=True, upload_to='', verbose_name='Image Mobile')),
                ('infolink', models.URLField(blank=True, max_length=9999999, null=True, verbose_name="Lien 'En savoir plus'")),
                ('argumentaire', models.TextField(blank=True, null=True, verbose_name='Argumentaire pour la consultation')),
                ('slug', models.SlugField(blank=True, null=True, unique=True)),
                ('address', models.CharField(blank=True, max_length=255, null=True, verbose_name='Adresse')),
                ('city', models.CharField(blank=True, max_length=255, null=True, verbose_name='Ville')),
                ('postcode', models.CharField(blank=True, max_length=255, null=True, verbose_name='Code postal')),
                ('lat', models.DecimalField(blank=True, decimal_places=12, max_digits=15, null=True, verbose_name='Latitude')),
                ('lng', models.DecimalField(blank=True, decimal_places=12, max_digits=15, null=True, verbose_name='Longitude')),
                ('author', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.SET_NULL, related_name='created_consultation', to=settings.AUTH_USER_MODEL)),
                ('shortLink', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.SET_NULL, related_name='consultationShortLink', to='risefor_lobbying.UrlShortner', verbose_name='Short Link')),
                ('tags', models.ManyToManyField(blank=True, null=True, to='risefor_lobbying.Tag', verbose_name='Consultation tags')),
            ],
            options={
                'ordering': ['-created_at'],
            },
        ),
    ]
