# Generated by Django 2.2.16 on 2024-03-19 10:21

from django.db import migrations, models
import django.db.models.deletion
import djangoldp.fields


class Migration(migrations.Migration):

    dependencies = [
        ('risefor_lobbying', '0172_delete_loomiotopic'),
    ]

    operations = [
        migrations.CreateModel(
            name='AppelSoutien',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('urlid', djangoldp.fields.LDPUrlField(blank=True, null=True, unique=True)),
                ('is_backlink', models.BooleanField(default=False, help_text='set automatically to indicate the Model is a backlink')),
                ('allow_create_backlink', models.BooleanField(default=True, help_text='set to False to disable backlink creation after Model save')),
                ('created_at', models.DateTimeField(auto_now_add=True)),
                ('name', models.CharField(max_length=255, verbose_name="Nom de l'appel")),
                ('status', models.CharField(choices=[('active', 'Active'), ('pending', 'Pending'), ('inappropriate', 'Inappropriate'), ('finished', 'Finished Action')], default='active', max_length=32, verbose_name='action status')),
                ('objective', models.TextField(verbose_name='Objectif')),
                ('description', models.TextField(blank=True, null=True, verbose_name='Contexte / Description (préambule)')),
                ('image', models.ImageField(blank=True, null=True, upload_to='', verbose_name='Image bannière')),
                ('documentTelecharger', models.FileField(blank=True, null=True, upload_to='', verbose_name='Document à télécharger - PDF')),
            ],
            options={
                'ordering': ['created_at'],
            },
        ),
        migrations.CreateModel(
            name='OrganisationSupporter',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('urlid', djangoldp.fields.LDPUrlField(blank=True, null=True, unique=True)),
                ('is_backlink', models.BooleanField(default=False, help_text='set automatically to indicate the Model is a backlink')),
                ('allow_create_backlink', models.BooleanField(default=True, help_text='set to False to disable backlink creation after Model save')),
                ('created_at', models.DateTimeField(auto_now_add=True)),
                ('organisationName', models.CharField(max_length=350, verbose_name="Nom de l'organisation")),
                ('address', models.CharField(max_length=350, verbose_name='Adresse postale complète')),
                ('citizenFullName', models.CharField(max_length=350, verbose_name='Nom, Prénom')),
                ('citizenPosition', models.CharField(max_length=350, verbose_name="Position dans l'organisation")),
                ('email', models.CharField(max_length=350, verbose_name='Email')),
                ('optin1', models.BooleanField(default=False)),
                ('optin2', models.BooleanField(default=False)),
                ('linkedSupport', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='risefor_lobbying.AppelSoutien', verbose_name="Signature à l'appel")),
                ('organisationType', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='risefor_lobbying.HelpOrgType', verbose_name='Type de collectif')),
            ],
            options={
                'ordering': ['-created_at'],
            },
        ),
        migrations.DeleteModel(
            name='TextSupporters_Email',
        ),
        migrations.RemoveField(
            model_name='textsupporter',
            name='supportedEmail',
        ),
        migrations.RemoveField(
            model_name='textsupporter',
            name='supportedGroup',
        ),
        migrations.RemoveField(
            model_name='textsupporter',
            name='supporterCollectif',
        ),
        migrations.RemoveField(
            model_name='textsupporter',
            name='supporterFirstname',
        ),
        migrations.RemoveField(
            model_name='textsupporter',
            name='supporterLastname',
        ),
        migrations.AddField(
            model_name='textsupporter',
            name='address',
            field=models.CharField(default='adresse', max_length=350, verbose_name='Adresse postale complète'),
        ),
        migrations.AddField(
            model_name='textsupporter',
            name='email',
            field=models.CharField(default='adresse', max_length=350, verbose_name='Email'),
        ),
        migrations.AddField(
            model_name='textsupporter',
            name='fullname',
            field=models.CharField(default='nom/prenoms', max_length=350, verbose_name='Nom, Prénom'),
        ),
        migrations.AddField(
            model_name='textsupporter',
            name='number',
            field=models.CharField(blank=True, max_length=20, null=True, verbose_name='Numéro de téléphone'),
        ),
        migrations.AddField(
            model_name='textsupporter',
            name='optin',
            field=models.BooleanField(default=False),
        ),
        migrations.AddField(
            model_name='textsupporter',
            name='linkedSupport',
            field=models.ForeignKey(default='', on_delete=django.db.models.deletion.CASCADE, to='risefor_lobbying.AppelSoutien', verbose_name="Signature à l'appel"),
        ),
    ]
