# Generated by Django 2.2.16 on 2024-10-14 11:10

from django.db import migrations, models
import djangoldp.fields


class Migration(migrations.Migration):

    dependencies = [
        ('risefor_lobbying', '0217_auto_20241010_1344'),
    ]

    operations = [
        migrations.CreateModel(
            name='assembleeParlementaireInternationale',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('urlid', djangoldp.fields.LDPUrlField(blank=True, null=True, unique=True)),
                ('is_backlink', models.BooleanField(default=False, help_text='set automatically to indicate the Model is a backlink')),
                ('allow_create_backlink', models.BooleanField(default=True, help_text='set to False to disable backlink creation after Model save')),
                ('name', models.CharField(blank=True, max_length=500, null=True, verbose_name='Nom de la commission')),
            ],
        ),
        migrations.CreateModel(
            name='delegationAssemblee',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('urlid', djangoldp.fields.LDPUrlField(blank=True, null=True, unique=True)),
                ('is_backlink', models.BooleanField(default=False, help_text='set automatically to indicate the Model is a backlink')),
                ('allow_create_backlink', models.BooleanField(default=True, help_text='set to False to disable backlink creation after Model save')),
                ('name', models.CharField(blank=True, max_length=250, null=True, verbose_name="Fonction de l'élu")),
            ],
        ),
        migrations.CreateModel(
            name='groupePolitiqueParlement',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('urlid', djangoldp.fields.LDPUrlField(blank=True, null=True, unique=True)),
                ('is_backlink', models.BooleanField(default=False, help_text='set automatically to indicate the Model is a backlink')),
                ('allow_create_backlink', models.BooleanField(default=True, help_text='set to False to disable backlink creation after Model save')),
                ('name', models.CharField(max_length=500, verbose_name='Nom du parti')),
            ],
        ),
        migrations.CreateModel(
            name='missionInformation',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('urlid', djangoldp.fields.LDPUrlField(blank=True, null=True, unique=True)),
                ('is_backlink', models.BooleanField(default=False, help_text='set automatically to indicate the Model is a backlink')),
                ('allow_create_backlink', models.BooleanField(default=True, help_text='set to False to disable backlink creation after Model save')),
                ('name', models.CharField(blank=True, max_length=500, null=True, verbose_name='Nom de la commission')),
            ],
        ),
        migrations.CreateModel(
            name='officeParlementaire',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('urlid', djangoldp.fields.LDPUrlField(blank=True, null=True, unique=True)),
                ('is_backlink', models.BooleanField(default=False, help_text='set automatically to indicate the Model is a backlink')),
                ('allow_create_backlink', models.BooleanField(default=True, help_text='set to False to disable backlink creation after Model save')),
                ('name', models.CharField(blank=True, max_length=500, null=True, verbose_name='Nom de la commission')),
            ],
        ),
        migrations.AddField(
            model_name='representative',
            name='instagram',
            field=models.CharField(blank=True, max_length=300, null=True, verbose_name='Instagram'),
        ),
        migrations.AddField(
            model_name='representative',
            name='linkedin',
            field=models.CharField(blank=True, max_length=300, null=True, verbose_name='Linkedin'),
        ),
        migrations.AlterField(
            model_name='additionalfunction',
            name='name',
            field=models.CharField(blank=True, max_length=500, null=True, verbose_name='Fonction additionnelle'),
        ),
        migrations.AlterField(
            model_name='phone',
            name='number',
            field=models.CharField(max_length=160, verbose_name='Numéro de téléphone'),
        ),
        migrations.AlterField(
            model_name='representative',
            name='additionalFunctions',
            field=models.ManyToManyField(blank=True, to='risefor_lobbying.additionalFunction', verbose_name='Fonctions additionnels'),
        ),
        migrations.RemoveField(
            model_name='representative',
            name='politicalParty',
        ),
        migrations.AddField(
            model_name='representative',
            name='assembleeParlementaireInternationales',
            field=models.ManyToManyField(blank=True, to='risefor_lobbying.assembleeParlementaireInternationale', verbose_name='Assemblée Parlementaire Intenationale'),
        ),
        migrations.AddField(
            model_name='representative',
            name='delegationAssemblees',
            field=models.ManyToManyField(blank=True, to='risefor_lobbying.delegationAssemblee', verbose_name='Delegation Assemblee'),
        ),
        migrations.AddField(
            model_name='representative',
            name='missionInformations',
            field=models.ManyToManyField(blank=True, to='risefor_lobbying.missionInformation', verbose_name="Mission d'informations"),
        ),
        migrations.AddField(
            model_name='representative',
            name='officeParlementaires',
            field=models.ManyToManyField(blank=True, to='risefor_lobbying.officeParlementaire', verbose_name='Office Parlementaire'),
        ),
        migrations.AddField(
            model_name='representative',
            name='politicalParty',
            field=models.ManyToManyField(blank=True, related_name='politicalParty', to='risefor_lobbying.groupePolitiqueParlement', verbose_name='Parti politique'),
        ),
    ]
