from modeltranslation.translator import register,translator, TranslationOptions
from .models import ActionGroup,representativeFunction,representativeContactPlateform

# A translation option is a class that declares which fields of a model to translate
# registering it with the translator creates duplicate columns for each language, in the database
# (https://django-modeltranslation.readthedocs.io/en/latest/registration.html#changes-automatically-applied-to-the-model-class)


class ActionGroupTranslationOptions(TranslationOptions):
    fields = ()
    #required_languages = ('en', 'de') #- by default languages are optional
    #required_languages = {'fr': ('name', 'Nom de l\'action'), 'default': ('name','Action Name')} - fine-grained control
translator.register(ActionGroup, ActionGroupTranslationOptions)



class representativeFunctionTranslationOptions(TranslationOptions):
    fields = ('name',)
    #required_languages = ('en', 'de') - by default languages are optional
    #required_languages = {'de': ('title', 'text'), 'default': ('title',)} - fine-grained control
translator.register(representativeFunction, representativeFunctionTranslationOptions)

class representativeContactPlateformTranslationOptions(TranslationOptions):
    fields = ('name',)
    #required_languages = ('en', 'de') - by default languages are optional
    #required_languages = {'de': ('title', 'text'), 'default': ('title',)} - fine-grained control
translator.register(representativeContactPlateform, representativeContactPlateformTranslationOptions)

